aboutsummaryrefslogtreecommitdiffstats
path: root/util/grub.d/10_hurd.in
diff options
context:
space:
mode:
Diffstat (limited to 'util/grub.d/10_hurd.in')
-rw-r--r--util/grub.d/10_hurd.in127
1 files changed, 127 insertions, 0 deletions
diff --git a/util/grub.d/10_hurd.in b/util/grub.d/10_hurd.in
new file mode 100644
index 0000000..8c54eab
--- /dev/null
+++ b/util/grub.d/10_hurd.in
@@ -0,0 +1,127 @@
+#! /bin/sh
+set -e
+
+# grub-mkconfig helper script.
+# Copyright (C) 2006,2007,2008,2009,2010 Free Software Foundation, Inc.
+#
+# GRUB is free software: you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation, either version 3 of the License, or
+# (at your option) any later version.
+#
+# GRUB is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
+# GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License
+# along with GRUB. If not, see <http://www.gnu.org/licenses/>.
+
+prefix=@prefix@
+exec_prefix=@exec_prefix@
+libdir=@libdir@
+. ${libdir}/grub/grub-mkconfig_lib
+
+CLASS="--class gnu --class os"
+
+if [ "x${GRUB_DISTRIBUTOR}" = "x" ] ; then
+ OS=GNU
+else
+ OS="${GRUB_DISTRIBUTOR} GNU/Hurd"
+ CLASS="--class $(echo ${GRUB_DISTRIBUTOR} | tr 'A-Z' 'a-z' | cut -d' ' -f1) ${CLASS}"
+fi
+
+at_least_one=false
+all_of_them=true
+
+# FIXME: add l4 here?
+kernel=
+for i in /boot/gnumach* ; do
+ if test -e $i ; then
+ basename=`basename $i`
+ dirname=`dirname $i`
+ rel_dirname=`make_system_path_relative_to_its_root $dirname`
+ echo "Found GNU Mach: $i" >&2
+ kernels="${kernels} ${rel_dirname}/${basename}"
+ at_least_one=true
+ fi
+done
+
+# FIXME: This works for ext2. For other filesystems we might need special-casing
+case "${GRUB_FS}" in
+ *fs) hurd_fs="${GRUB_FS}" ;;
+ *) hurd_fs="${GRUB_FS}fs" ;;
+esac
+
+for i in /hurd/${hurd_fs}.static /hurd/exec ; do
+ if test -e "$i" ; then
+ echo "Found Hurd module: $i" >&2
+ at_least_one=true
+ else
+ all_of_them=false
+ fi
+done
+
+if ${at_least_one} ; then : ; else
+ # no hurd here, aborting silently
+ exit 0
+fi
+
+if ${all_of_them} && test -e /lib/ld.so.1 ; then : ; else
+ echo "Some Hurd stuff found, but not enough to boot." >&2
+ exit 1
+fi
+
+for kernel in ${kernels}
+do
+ kernel_base="`basename "${kernel}"`"
+ KERNEL="using ${kernel_base}"
+
+ cat << EOF
+menuentry "${OS} ${KERNEL}" ${CLASS} {
+EOF
+ prepare_grub_to_access_device ${GRUB_DEVICE_BOOT} | sed -e "s/^/\t/"
+ message="$(gettext_printf "Loading GNU Mach ...")"
+ cat << EOF
+ echo '$message'
+ multiboot ${kernel} root=device:${GRUB_DEVICE#/dev/}
+EOF
+ save_default_entry | sed -e "s/^/\t/"
+ prepare_grub_to_access_device ${GRUB_DEVICE} | sed -e "s/^/\t/"
+ message="$(gettext_printf "Loading the Hurd ...")"
+ cat << EOF
+ echo '$message'
+ module /hurd/${hurd_fs}.static ${hurd_fs} --readonly \\
+ --multiboot-command-line='\${kernel-command-line}' \\
+ --host-priv-port='\${host-port}' \\
+ --device-master-port='\${device-port}' \\
+ --exec-server-task='\${exec-task}' -T typed '\${root}' \\
+ '\$(task-create)' '\$(task-resume)'
+ module /lib/ld.so.1 exec /hurd/exec '\$(exec-task=task-create)'
+}
+EOF
+
+ cat << EOF
+menuentry "${OS} ${KERNEL} (recovery mode)" ${CLASS} {
+EOF
+ prepare_grub_to_access_device ${GRUB_DEVICE_BOOT} | sed -e "s/^/\t/"
+ message="$(gettext_printf "Loading GNU Mach ...")"
+ cat << EOF
+ echo '$message'
+ multiboot ${kernel} root=device:${GRUB_DEVICE#/dev/} -s
+EOF
+ prepare_grub_to_access_device ${GRUB_DEVICE} | sed -e "s/^/\t/"
+ message="$(gettext_printf "Loading the Hurd ...")"
+ cat << EOF
+ echo '$message'
+ module /hurd/${hurd_fs}.static ${hurd_fs} \\
+ --multiboot-command-line='\${kernel-command-line}' \\
+ --host-priv-port='\${host-port}' \\
+ --device-master-port='\${device-port}' \\
+ --exec-server-task='\${exec-task}' -T typed '\${root}' \\
+ '\$(task-create)' '\$(task-resume)'
+ module /lib/ld.so.1 exec /hurd/exec '\$(exec-task=task-create)'
+}
+EOF
+
+done